unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, MD5, ActnList, ExtActns;

type
  TForm2 = class(TForm)
    ListView1: TListView;
    Button1: TButton;
    Button2: TButton;
    Button4: TButton;
    Timer1: TTimer;
    ActionList1: TActionList;
    FileRun1: TFileRun;
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form2: TForm2;

implementation

uses Unit1;

{$R *.dfm}

procedure TForm2.Button1Click(Sender: TObject);
var
  sl: TStringList;
  Item: TListItem;
  Target: string;
  i, j: Integer;
begin
  sl := TStringList.Create;
  try
    i := 0;
    for Item in ListView1.Items do
    if Item.Checked then
    inc(i);

    j := 0;
    for Item in ListView1.Items do
    if Item.Checked then
    begin
      Target := IncludeTrailingPathDelimiter(Form1.Edit1.Text) + StringReplace(Item.Caption, '/', '\', [rfReplaceAll]) + '.gz';
      ForceDirectories(ExtractFilePath(Target));
      inc(j);
      sl.Add('echo Herunterladen von Datei ' + IntToStr(j) + '/' + IntToStr(i));
      if Form1.ComboBox1.ItemIndex = 0 then
      sl.Add('wget http://ftp.4players.de/pub/hosted/ts3/updater-images/client/' +
             Form1.ComboBox2.Text + '/' + ListView1.Groups[Item.GroupID].Header + '/' + Item.SubItems[6] +
             ' -O "' + Target + '"')
      else
      sl.Add('wget http://files.teamspeak-services.com/updater-images/client/' +
             Form1.ComboBox2.Text + '/' + ListView1.Groups[Item.GroupID].Header + '/' + Item.SubItems[6] +
             ' -O "' + Target + '"');
    end;
    sl.SaveToFile(ExtractFilePath(paramstr(0)) + 'download.bat');
    Sleep(100);
  finally
    sl.Free;
  end;
  FileRun1.FileName := ExtractFilePath(paramstr(0)) + 'download.bat';
  FileRun1.Execute;
end;

procedure TForm2.Button2Click(Sender: TObject);
var
  sl: TStringList;
  Item: TListItem;
  Target: string;
begin
  sl := TStringList.Create;
  try
    for Item in ListView1.Items do
    if Item.Checked then
    begin
      Target := IncludeTrailingPathDelimiter(Form1.Edit1.Text) + StringReplace(Item.Caption, '/', '\', [rfReplaceAll]) + '.gz';
      sl.Add('gzip -d -n -f "' + Target + '"');
    end;
    sl.SaveToFile(ExtractFilePath(paramstr(0)) + 'extract.bat');
    Sleep(100);
  finally
    sl.Free;
  end;
  FileRun1.FileName := ExtractFilePath(paramstr(0)) + 'extract.bat';
  FileRun1.Execute;
end;

procedure TForm2.Timer1Timer(Sender: TObject);
function GetFileSize(const FileName: string): Int64;
var
  FileStream: TFileStream;
begin
  FileStream := TFileStream.Create(FileName, fmOpenRead or fmShareDenyNone);
  try
    try
      Result := FileStream.Size;
    except
      Result := 0;
    end;
  finally
    FileStream.Free;
  end;
end;
var
  Item: TListItem;
  Target: string;

begin
  Timer1.Enabled := False;
  for Item in ListView1.Items do
  begin
    Target := IncludeTrailingPathDelimiter(Form1.Edit1.Text) + StringReplace(Item.Caption, '/', '\', [rfReplaceAll]);
    if FileExists(Target) then
    begin
      Item.SubItems[0] := IntToStr(GetFileSize(Target));
      Item.SubItems[1] := MD5.MD5Print(MD5.MD5File(Target));
      if Item.SubItems[0] = Item.SubItems[2] then
      if Item.SubItems[1] = Item.SubItems[3] then
      Continue;
    end;

    Item.Checked := True;
  end;
end;

end.
