unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, RedeemerXML, inifiles, MD5, Unit2;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    ComboBox1: TComboBox;
    Label4: TLabel;
    ComboBox2: TComboBox;
    Button3: TButton;
    Button4: TButton;
    IdHTTP1: TIdHTTP;
    Label5: TLabel;
    ComboBox3: TComboBox;
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    var
      INI: TINIFile;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button3Click(Sender: TObject);
var
  INI: TINIFile;
  sl: TStringList;
procedure ReadINI(const Section: string);
var
  sl: TStringList;
  temp: TStringList;
  s: string;
  i: Integer;
begin
  sl := TStringList.Create;
  INI.ReadSection(Section, sl);
  Form2.ListView1.Groups.Add.Header := Section;
  i := Form2.ListView1.Groups.Count - 1;
  temp := TStringList.Create;
  for s in sl do
  try
    temp.Text := StringReplace(INI.ReadString(Section, s, ''), '::', #13#10, [rfReplaceAll]);
    with Form2.ListView1.Items.Add do
    begin
      Caption := temp[4];
      SubItems.Add('');
      SubItems.Add('');
      SubItems.Add(temp[3]);
      SubItems.Add(temp[2]);
      SubItems.Add(temp[1]);
      SubItems.Add(temp[0]);
      SubItems.Add(StringReplace(s, '\', '/', [rfReplaceAll]));
      GroupID := i;
    end;
  except
  end;
  temp.Free;
  sl.Free;
end;
begin
  if ComboBox1.ItemIndex = -1 then Exit;
  if ComboBox3.ItemIndex = -1 then Exit;
  if ComboBox2.ItemIndex = -1 then Exit;

  sl := TStringList.Create;
  if ComboBox1.ItemIndex = 0 then
  sl.Text := IdHTTP1.Get('http://ftp.4players.de/pub/hosted/ts3/updater-images/client/' + ComboBox2.Text + '/client_' + ComboBox3.Text + '.ini')
  else
  sl.Text := IdHTTP1.Get('http://files.teamspeak-services.com/updater-images/client/' + ComboBox2.Text + '/client_' + ComboBox3.Text + '.ini');
  sl.SaveToFile(ExtractFilePath(paramstr(0))+ 'Anydate.tmp');
  Application.CreateForm(TForm2, Form2);
  INI := TIniFile.Create(ExtractFilePath(paramstr(0))+ 'Anydate.tmp');
  ReadINI('common_client');
  ReadINI('bin_' + ComboBox3.Text);
  INI.Free;
  Form2.Timer1.Enabled := True;
  Form2.ShowModal;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  INI.WriteString('Anydate','TS3',Edit1.Text);
  INI.WriteInteger('Anydate','Platform',Combobox3.ItemIndex);
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
procedure AddIfVersion(s: string);
begin
  s := StringReplace(s, '/', '', [rfReplaceAll]);
  try
    StrToInt(s);
    ComboBox2.Items.Add(s);
  except
  end;
end;
var
  s: string;
  XML: TRedeemerXML;
begin
  ComboBox2.Items.Clear;
  if ComboBox1.ItemIndex = 1 then
  s := IdHTTP1.Get('http://files.teamspeak-services.com/updater-images/client/')
  else
  s := IdHTTP1.Get('http://ftp.4players.de/pub/hosted/ts3/updater-images/client/');

  XML := TRedeemerXML.Create(s);
  while XML.GoToAndGetNextTag do
  if XML.CurrentTag = 'a' then
  AddIfVersion(XML.GetAttribute('href'));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  INI := TIniFile.Create(ExtractFilePath(paramstr(0))+ 'Anydate.ini');
  Edit1.Text := INI.ReadString('Anydate','TS3','');
  ComboBox3.ItemIndex := INI.ReadInteger('Anydate','Platform',3);
end;

end.
